#!/usr/bin/env python
# -*- Python -*-

import sys
import time
import os
from math import *

from set_env import *
sys.path.append(Rh2LibDir +'/tools/geo')
from geo import *

############################################
#points for a sample motion (vertical grab)
#########################################3##
pa = [  350,    0.0,    0.0,   0.0, 180.0, 0.0]
pb = [  350,    0.0,    100,   0.0, 180.0, 0.0]
pc = [  350.0,  0.0,    240.0, 0.0, 180.0, 0.0]
pd = [  250.0, -250.0,  240.0, 0.0, 180.0, 0.0]
pe = [  0.0,   -350.0,  240.0, 0.0, 180.0, 0.0]
pf = [ -250.0, -250.0,  260.0, 0.0, 180.0, 0.0]

cam = [ -260.0, -190.0,  300.0, 0.0, 180.0, 0.0]

#position of a trush
ptrush = [  400.0,  0.0,    220.0, 0.0, 180.0, 0.0]

#cans position 
pcan1 = [-265.0, -270.0]
pcan2 = [-265.0, -170.0]
pcan3 = [-165.0, -270.0]

#offset of gripper position to grab a can 
offx = 0.0
offy = -22.5

#drink position list to grab
drink = {}
drink["can1"]=[ pcan1[0]+offx, pcan1[1]+offy,  135.5, 0.0, 180.0, 0.0]
drink["can2"]=[ pcan2[0]+offx, pcan2[1]+offy,  135.5, 0.0, 180.0, 0.0]
drink["can3"]=[ pcan3[0]+offx, pcan3[1]+offy,  135.5, 0.0, 180.0, 0.0]
