// -*-C++-*-
/*!
 * @file  BatteryWatcherSVC_impl.h
 * @brief Service implementation header of BatteryWatcher.idl
 *
 */

#include "BatteryWatcherSkel.h"
#include <iostream>

#ifndef BATTERYWATCHERSVC_IMPL_H
#define BATTERYWATCHERSVC_IMPL_H
 
/*!
 * @class BatteryAlertSVC_impl
 * Example class implementing IDL interface BatteryAlert
 */
class BatteryAlertSVC_impl
 : public virtual POA_BatteryAlert,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~BatteryAlertSVC_impl();

 public:
  /*!
   * @brief standard constructor
   */
   BatteryAlertSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~BatteryAlertSVC_impl();

   // attributes and operations
   void RH_InVoltageAlert(CORBA::Float voltage);

   int iamhungry; //battery alert flag

};



#endif // BATTERYWATCHERSVC_IMPL_H


