// -*-C++-*-
/*!
 * @file  soundSVC_impl.h
 * @brief Service implementation header of sound.idl
 *
 */

#include "soundSkel.h"
#include <string>
#include <stdlib.h>

#ifndef SOUNDSVC_IMPL_H
#define SOUNDSVC_IMPL_H
 
/*!
 * @class PlaySoundSVC_impl
 * Example class implementing IDL interface PlaySound
 */
class PlaySoundSVC_impl
 : public virtual POA_PlaySound,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~PlaySoundSVC_impl();

 public:
  /*!
   * @brief standard constructor
   */
   PlaySoundSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~PlaySoundSVC_impl();

   // attributes and operations
   void play();
   std::string fname;
};



#endif // SOUNDSVC_IMPL_H


